Основы написания скриптов в FreeCAD

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page FreeCAD Scripting Basics and the translation is 81% complete.
Outdated translations are marked like this.
Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文(中国大陆)‎

Написание сценариев Python в FreeCAD

FreeCAD с начала построен так, чтобы быть полностью контролируемым сценариями Python. Почти все части FreeCAD, такие как интерфейс, содержимое сцены, и даже представление этого содержания в окне 3D просмотра доступны из встроенного Python интерпретатора или из своих собственных сценариев. Как результат, FreeCAD вероятно, является одной из наиболее глубоко настраиваемый инженерных приложений, доступных сегодня.

Если вы не знакомы с Python, мы рекомендуем Вам искать учебники по интернету, и бегло взглянуть на его структуру. Python это очень простой язык для обучения, особенно потому, он может быть сразу запущен внутри интерпритатора, где и простая команда и готовая программа может быть выполнена "на лету", без необходимости компилировать что-либо. FreeCAD имеет встроенный в Python интерпритатор. Если вы не видите окно с надписью Консоль Python, как показано ниже, вы можете активировать его через Вид → Панели → Консоль Python.

Интерпретатор

В интерпретаторе вы можете получить доступ к установленным в вашей системе модулям Python, а также встроенным модулям FreeCAD, и всем дополнительным модулям FreeCAD что вы установите позже. Скриншот ниже показывает интерпретатор Python:

The FreeCAD Python interpreter

В интепритаторе, вы можете выполнять код Python и просматривать доступные классы и функции. FreeCAD предоставляет очень удобный браузер классов для освоения мира FreeCAD: Когда вы вводите имя известного класса после точки сразу же появляется (то есть вы хотите добавить что-то из этого класса), окно браузера, где вы можете перемещаться между имеющимися подклассами и методами. При выборе если существует, связанный текст справка, то он отображается:

The FreeCAD class browser

Таким образом, сначало наберите App. или Gui. посмотрите, что происходит. Другой, более общий Python метод изучения содержимого модулей и классов является использование команды print(dir()). Например, ввод print(dir()) выведет список всех модулей, загруженных в FreeCAD. print(dir(App)) покажет вам все, что содержит App модуль и т.д.

Еще одна полезная особенность интерпритатора возможность вернуться назад по истории команд и извлечь строки кода, которые вы уже набрали ранее. Для перемещения по истории команд, просто используйте Up arrow или Down arrow.

Щелкнув правой кнопкой мыши в окне интерпритатора, у вас также есть несколько других опций, таких как копирование всей истории (полезно для эксперимента что-то сделать, а затем получить полный сценарий этого), или вставить имя файла с полным путем.

top

Python Help

В меню Справка, вы найдете раздел Автоматически сгенерированная документация python, при открытии которого откроется окно браузера, содержащего полную, создаваемую в реальном времени, документацию всех модулей Python, доступных в интерпретаторе FreeCAD, встроенных модулях Python и FreeCAD, установленных в систему модулей и дополнительные модулей FreeCAD. Доступна ли документация зависит от того, сколько усилий разработчик каждого модуля приложил к документированию своего кода, но, как правило Python модули имеют репутацию хорошо задокументированных. Ваше окно FreeCAD должно оставаться открытым для того чтобы система документации работала. В разделе Документация по созданию скриптов на Python находится ссылка на этот вики-раздел Power users hub.

top

Встроеные модули

Поскольку FreeCAD спроектирован с возможностью запуска без графического интерфейса пользователя (Graphical User Interface, GUI), почти все функциональные возможности разделены на две группы: Базовая функциональности, названные App, и функциональность интерфейса, названный Gui. Эти два модуля можно также подключить из сценариев, вне интерпретатора, под названиями FreeCAD и FreeCADGui соответственно.

  • В модуле App вы найдете все, связанное с самим приложением, такие методы как открытия или закрытия файлов, а также документов, как настройка активного документа или объявление его содержания.
  • В модуле Gui вы найдете инструменты для доступа и управления элементами графического интерфейса, такими как инструментарии и и их панели инструментов, и, что более интересно, графическое представление всего содержимого FreeCAD.

Перелистывание содержимого этих модулей не слишком полезно, поскольку они растут довольно быстро с развитием FreeCAD. Но два инструмента просмотра (браузер классов и справка Python) должны обеспечить вас полной и актуальной документацией в любой момент.

top

Объекты модулей App и Gui

Как мы уже говорили, в FreeCAD, всё разделенные между основным и представлением. Это подразумевает и 3D-объекты. Вы можете получить доступ определяющим свойствам объектов (одна из особенностей FreeCAD) с помощью модуля App, и изменить то, как они представлены на экране с помощью модуля Gui. Например, куб имеет свойства, которые определяют его, такие как ширина, длина, высота, они хранятся в объекте App, а свойства представления, такие как цвета граней, режим отрисовки, хранятся в соответствующем объекте Gui.

Этот способ обладает очень широким спектром применения, как с алгоритмами работы только с определеной частью функций, не нужно заботиться о какой-либо визуальной части, или даже перенаправления содержания документов не-графических приложений, таких как списки, таблицы или элементный анализ.

Для каждого объекта App в вашем документе существует соответствующий объект Gui. Фактически и сам документ содержит объекты App и Gui. Это, конечно, действует только при запуске FreeCAD с полным интерфейсом. В режиме командной строки графического интерфейса нет, так что доступны только объекты App. Обратите внимание, что часть объектов Gui создается снова каждый раз когда объект App отмечен как "подлежащий пересчёту" (например, когда один из его параметров изменился), поэтому изменения, которые вы могли сделать непосредственно на объекте Gui могут быть потеряны.

чтобы получить доступ к части App чего-либо, введите:

myObject = App.ActiveDocument.getObject("ObjectName")

где "ObjectName" это имя вашего объекта. Вы также можете ввести:

myObject = App.ActiveDocument.ObjectName

чтобы получить доступ к части Gui того же объекта, введите:

myViewObject = Gui.ActiveDocument.getObject("ObjectName")

где "ObjectName" - имя вашего объекта. Вы также можете ввести:

myViewObject = App.ActiveDocument.ObjectName.ViewObject

Если мы находимся в режиме командной строки и графического интерфейса нет, последняя строка вернет None.

top

Объекты документа

В FreeCAD всё, над чем вы работаете, находится внутри документов. Документ содержит вашу геометрию и может быть сохранен в файл. Одновременно может быть открыто несколько документов. Документ, также как и геометрия, содержащиеся внутри него, имеет объекты App и Gui. Объект App содержит фактически определенную Вами геометрию, в то время как объект Gui содержит различные отображения из вашего документа. Вы можете открывать несколько окон, каждое из которых отображение вашей работы с различным масштабом или точкой зрения. Эти виды входят в объект Gui вашего документа.

Чтобы получить доступ к части App текущего открытого (активного) документа, введите:

myDocument = App.ActiveDocument

Чтобы создать новый документ, введите:

myDocument = App.newDocument("Document Name")

Чтобы получить доступ к части Gui текущего открытого (активного) документа, введите:

myGuiDocument = Gui.ActiveDocument

чтобы получить доступ к текущему виду, введите:

myView = Gui.ActiveDocument.ActiveView

top

Использование дополнительных модулей

Модули FreeCAD и FreeCADGui отвечают за создание и управление объектами в документе FreeCAD. Они не занимаются созданием или изменением геометрии. Это потому, что эта геометрия может быть нескольких типов, и поэтому она управляется дополнительными модулями, каждый из которых отвечает за управление определенным типом геометрии. Например, Модуль Part использует ядро OpenCascade и поэтому может создавать и манипулировать геометрией типа B-rep. В то же время Модуль Mesh может создавать и модифицировать объекты типа сетка. Таким образом, FreeCAD может обрабатывать самые разные типы объектов, которые могут сосуществовать в одном документе, и новые типы могут быть легко добавлены в будущем.

top

Создание объектов

Каждый модуль имеет свой собственный способ обработки своей геометрии, но обычно они все могут создавать объекты в документе. Но документ FreeCAD также знает о доступных типах объектов, предоставляемых модулями:

FreeCAD.ActiveDocument.supportedTypes()

перечислит все возможные объекты, которые вы можете создать. Например, давайте создадим сетку (поддерживаемую модулем Mesh) и деталь (поддерживаемую модулем Part):

myMesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "myMeshName")
myPart = FreeCAD.ActiveDocument.addObject("Part::Feature", "myPartName")

Первый аргумент - это тип объекта, второй - имя объекта. Наши два объекта выглядят почти одинаково: они еще не содержат никакой геометрии, и большинство их свойств одинаковы, когда вы проверяете их с помощью dir(myMesh) и dir(myPart). За исключением одного, myMesh имеет свойство Mesh, а myPart - свойство Shape. Здесь хранятся данные Mesh и Part. Например, давайте создадим куб Part и сохраним его в нашем объекте myPart:

import Part
cube = Part.makeBox(2, 2, 2)
myPart.Shape = cube

Вы можете попытаться сохранить куб в свойстве Mesh объекта myMesh, он вернет сообщение об ошибке неправильного типа. Это происходит из-за того, что каждое свойство предназначены для хранения только определенного типа. В свойстве Mesh вы можете сохранять только то, что создано с помощью модуля Mesh. Обратите внимание, что большинство модулей также имеют ярлык для добавления своей геометрии в документ:

import Part
cube = Part.makeBox(2, 2, 2)
Part.show(cube)

top

Изменение объектов

Модификация объекта выполняется так же:

import Part
cube = Part.makeBox(2, 2, 2)
myPart.Shape = cube

Теперь давайте изменим форму на большую:

biggercube = Part.makeBox(5, 5, 5)
myPart.Shape = biggercube

top

Запрос объектов

Вы всегда можете посмотреть на тип объекта следующим образом:

myObj = FreeCAD.ActiveDocument.getObject("myObjectName")
print(myObj.TypeId)

или проверить, является ли объект производным от одного из базовых объектов (элемент детали, элемент сетки и т.д.):

print(myObj.isDerivedFrom("Part::Feature"))

Теперь вы действительно можете начать играть с FreeCAD! Насчёт полного списка всех доступных модулей и доступных инструментов смотрите в разделе Category:API.

top